import { TspClient } from 'tsp-typescript-client/lib/protocol/tsp-client';
import { TimeGraphEntry } from 'tsp-typescript-client/lib/models/timegraph';
import { TimeGraphStateComponent } from 'timeline-chart/lib/components/time-graph-state';
import { TimeGraphAnnotationComponent } from 'timeline-chart/lib/components/time-graph-annotation';
import { TimelineChart } from 'timeline-chart/lib/time-graph-model';
import { TimeRange } from 'traceviewer-base/lib/utils/time-range';
export declare class TspDataProvider {
    private client;
    private outputId;
    private traceUUID;
    private timeGraphEntries;
    private timeGraphRows;
    totalRange: bigint;
    constructor(client: TspClient, traceUUID: string, outputId: string);
    /**
     * @param ids requested entry ids
     * @param entries time graph entries
     * @param totalTimeRange total time range
     * @param viewRange requested view range relative to start of total time range
     * @param nbTimes number of requested time samples
     * @param annotationMarkers requested annotation categories
     * @returns time graph model
     */
    getData(ids: number[], entries: TimeGraphEntry[], totalTimeRange: TimeRange, worldRange?: TimelineChart.TimeGraphRange, nbTimes?: number, annotationMarkers?: string[], markerSetId?: string): Promise<TimelineChart.TimeGraphModel>;
    private getArrows;
    private timeGraphRowsOrdering;
    private getDefaultForGapStyle;
    private getRowModel;
    private getAnnotation;
    fetchStateTooltip(element: TimeGraphStateComponent, viewRange: TimeRange): Promise<{
        [key: string]: string;
    } | undefined>;
    fetchAnnotationTooltip(element: TimeGraphAnnotationComponent, viewRange: TimeRange): Promise<{
        [key: string]: string;
    } | undefined>;
}
//# sourceMappingURL=tsp-data-provider.d.ts.map