import * as React from 'react';
import { TreeNode } from './tree-node';
import { SortConfig } from './sort';
import ColumnHeader from './column-header';
interface FilterTreeProps {
    nodes: TreeNode[];
    showCheckboxes: boolean;
    showCloseIcons: boolean;
    showFilter: boolean;
    checkedSeries: number[];
    collapsedNodes: number[];
    selectedRow?: number;
    onToggleCheck: (ids: number[]) => void;
    onClose: (id: number) => void;
    onRowClick: (id: number) => void;
    onToggleCollapse: (id: number, nodes: TreeNode[]) => void;
    onOrderChange: (ids: number[]) => void;
    showHeader: boolean;
    headers: ColumnHeader[];
    className: string;
}
interface FilterTreeState {
    filteredNodes: TreeNode[];
    sortConfig: SortConfig[];
}
export declare class FilterTree extends React.Component<FilterTreeProps, FilterTreeState> {
    static defaultProps: Partial<FilterTreeProps>;
    constructor(props: FilterTreeProps);
    private _filter;
    getRootNodes: () => TreeNode[];
    getNode: (treeNodes: TreeNode[], id: number) => TreeNode | undefined;
    handleCollapse: (id: number) => void;
    handleClose: (id: number) => void;
    handleOrderChange: (nodes: TreeNode[]) => void;
    handleSortConfigChange: (sortConfig: SortConfig[]) => void;
    getAllChildrenIds: (node: TreeNode, ids: number[]) => number[];
    getParentIdsToCheck: (parentId: number, ids: number[], toCheck: boolean) => number[];
    isNodeChecked: (id: number) => boolean;
    areAllSiblingsChecked: (node: TreeNode) => boolean;
    handleCheck: (id: number) => void;
    getCheckedStatus: (id: number) => number;
    isEveryChildChecked: (node: TreeNode) => boolean;
    getAllLeavesId: (nodes: TreeNode[], ids: number[]) => number[];
    isSomeChildChecked: (node: TreeNode) => boolean;
    isCollapsed: (id: number) => boolean;
    handleFilterChanged: (filter: string) => void;
    getMatchingIds: (node: TreeNode, filter: string, foundIds: number[]) => boolean;
    filterTree: (nodes: TreeNode[], matchedIds: number[]) => TreeNode[];
    renderFilterTree: () => JSX.Element;
    renderTable: (nodes: TreeNode[]) => JSX.Element;
    render(): JSX.Element | undefined;
    componentDidUpdate(prevProps: FilterTreeProps): void;
}
export {};
//# sourceMappingURL=tree.d.ts.map