/// <reference types="chart.js" />
import { AbstractOutputProps } from './abstract-output-component';
import * as React from 'react';
import { TimeRange } from 'traceviewer-base/src/utils/time-range';
import { AbstractXYOutputState } from './abstract-xy-output-component';
import { AbstractXYOutputComponent } from './abstract-xy-output-component';
import { Experiment } from 'tsp-typescript-client';
declare type XYOutputOverviewState = AbstractXYOutputState & {
    shiftKey: boolean;
    showModal: boolean;
};
declare type XYOutputOverviewProps = AbstractOutputProps & {
    experiment: Experiment;
};
/**
 * The overview uses the viewRange for the orange overlay, selectionRange for the blue overlay.
 * It will only be setting these properties.
 */
export declare class XYOutputOverviewComponent extends AbstractXYOutputComponent<XYOutputOverviewProps, XYOutputOverviewState> {
    private initialViewRangeStartPosition;
    private initialViewRangeEndPosition;
    private viewRangeMoveStartOffsetX;
    private keyMapping;
    constructor(props: XYOutputOverviewProps);
    renderChart(): React.ReactNode;
    protected getDisplayedRange(): TimeRange;
    protected afterChartDraw(ctx: CanvasRenderingContext2D | null, chartArea?: Chart.ChartArea | null): void;
    protected getZoomTime(): bigint;
    private getKeyActionMap;
    private onKeyDown;
    private onKeyUp;
    private onMouseDown;
    private onMouseMove;
    private onMouseLeave;
    private onMidButtonClick;
    private onRightButtonClick;
    private onLeftButtonClick;
    private updateViewRange;
    private onWheel;
    private shiftKeyPress;
    protected getOutputComponentDomId(): string;
    protected getOutputComponentName(): string;
    protected getTitleBarTooltip(): string;
    protected showOptions(): React.ReactNode;
    private closeOverviewOutputSelector;
    private openOverviewOutputSelector;
    private toggleTree;
}
export {};
//# sourceMappingURL=xy-output-overview-component.d.ts.map